﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls;

namespace DragAndDropWithinTreeView
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private ObservableCollection<object> GenerateTreeViewData()
        {
            ObservableCollection<object> collection = new ObservableCollection<object>();
            for (int i = 0; i < 5; i++)
            {
                string name1 = string.Format("Item {0}", i);
                DataItem d1 = new DataItem();
                d1.Name = name1;

                for (int j = 0; j < 5; j++)
                {
                    string name2 = string.Format("Item {0}.{1}", i, j);
                    DataItem d2 = new DataItem();
                    d2.Name = name2;
                    d1.Children.Add(d2);
                }
                collection.Add(d1);
            }
            return collection;
        }

        public Window1()
        {
            InitializeComponent();

            this.treeView1.ItemsSource = this.GenerateTreeViewData();

            RadDragAndDropManager.AddDropInfoHandler(treeView1, OnDropInfo);
        }

        private void OnDropInfo(object sender, DragDropEventArgs e)
        {
            RadTreeViewItem item = e.Options.Destination as RadTreeViewItem;

            if (item.DropPosition == DropPosition.Inside)
            {
                item.IsDropAllowed = false;
            }
        }
    }

    public class DataItem
    {
        public DataItem()
        {
            this.Children = new ObservableCollection<DataItem>();
        }
        public string Name { get; set; }
        public ObservableCollection<DataItem> Children { get; set; }
    }
}
